Subject: Re: [RFC] dev->refcnt long term holder

From: Stephen Hemminger <[email-masked]>
Date: Tue, 17 Nov 2009 09:58:46 -0800

On Tue, 17 Nov 2009 00:30:19 -0800 (PST)
David Miller <[email-masked]> wrote:

> I'm trying to remember why we added this asynchronous link state event
> processing monster.  It probably has something to do with needing a
> sleepable context.  What's amusing is that linkwatch has repeatably
> caused RTNL deadlock issues over the years. :-)

I thought it was to handle:
 1) carrier on old devices would bounce, so it provides ratelimiting
    of state changes. Modern hardware and CPU's probably makes this a non-issue.
 2) wasn't there some code path with device changes, hotplug, uevent and
    udev that meant that we couldn't do notifiers immediately.

--